From 500400c35241b6258678ce4b69028b88006f4489 Mon Sep 17 00:00:00 2001
From: Ashutosh Bapat <ashutosh.bapat.oss@gmail.com>
Date: Mon, 28 Oct 2024 16:36:27 +0530
Subject: [PATCH v10 06/12] Property collation and edge-vertex link support

The commit has following changes.

1. collation of a property
--------------------------
The values with differing collations can not be collated. This means
that we will not able to compare, sort, or order values of properties
with the same name if they have different collations in different
elements or different labels.  This restricts the property's usage in
graph table query. Hence the collation of all the properties with the
same name needs to be the same. Enforce this.

Often the collation of a property reference is required before
graph_table is rewritten. For example, assign_query_collation() is
called during transformSelectStmt() which is called before calling
rewriteGraphTable(). Hence the collation of a property needs to be
accessible before any property reference is accessed. Hence the
collation of a property is stored in pg_propgraph_property.

Note: This is not explicitly specified in Section 9.15, "Consistency
check of a tabular property graph descriptor", syntax rule 4.c.iii.2 of
SQL/PGQ standard.

2. collation of source and destination keys of an edge
------------------------------------------------------
If collations of edge key and the corresponding referenced key differ,
an edge may end up being adjacent to undesired vertex. Prohibit such a
case when key columns are explicitly specified.

When edge and vertex keys are derived from the foreign key constraint,
we do not check collations again since the constraint itself ensures
one-to-many edge-to-vertex mapping.

Note: This is not specified in Section 9.14, "Creation of an edge table
descriptor".

3. Edge-vertex link quals
-----------------------------------------
When creating an edge element make sure that there exists an equality
operators that can be used to match vertex and edge keys. Fail the DDL if
such an operator does not exist. Use the same equality operators to build
vertex-edge quals in build_edge_vertex_link_quals(). Also add a
dependency of the edge on the equality operator so that it can not be
dropped without dropping the edge.

Note for reviewers:
The code in ATAddForeignKeyConstraint() looks up three different
equality operators and it's difficult to separate the code looking up
just PK=FK operators. So could not move some common code to a function
which can be used at both places.

4. Tests
--------
Adds tests for above items.

The collation tests, test that

a. the collation is correctly set for the columns projected by
GRAPH_TABLE clause.

b. quals corresponding to the various WHERE clause in GRAPH_TABLE have
correct collation set

c. quals corresponding to the edge-vertex links have correct collation
set.

Note: These tests combined with tests in collate.sql and other collation
specific tests indicate that we have covered all scenarios testing
collations in the context of GRAPH_TABLE. More collation specific tests
may be added as required.

Author: Ashutosh Bapat
---
 doc/src/sgml/catalogs.sgml                    |  49 ++++
 src/backend/catalog/information_schema.sql    |   8 +-
 src/backend/commands/propgraphcmds.c          | 222 +++++++++++++--
 src/backend/nodes/nodeFuncs.c                 |   5 +-
 src/backend/parser/parse_collate.c            |   8 +-
 src/backend/parser/parse_graphtable.c         |  16 +-
 src/backend/rewrite/rewriteGraphTable.c       | 122 ++++++--
 src/include/catalog/pg_propgraph_element.h    |  11 +
 src/include/catalog/pg_propgraph_property.h   |   6 +
 src/include/nodes/primnodes.h                 |   2 +
 .../expected/create_property_graph.out        | 261 +++++++++++++++---
 src/test/regress/expected/graph_table.out     | 111 +++++++-
 src/test/regress/expected/oidjoins.out        |   1 +
 .../regress/sql/create_property_graph.sql     |  77 ++++++
 src/test/regress/sql/graph_table.sql          |  41 ++-
 15 files changed, 816 insertions(+), 124 deletions(-)

diff --git a/doc/src/sgml/catalogs.sgml b/doc/src/sgml/catalogs.sgml
index bbb6f3957c2..62a8025196c 100644
--- a/doc/src/sgml/catalogs.sgml
+++ b/doc/src/sgml/catalogs.sgml
@@ -6455,6 +6455,18 @@ SCRAM-SHA-256$<replaceable>&lt;iteration count&gt;</replaceable>:<replaceable>&l
       </para></entry>
      </row>
 
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       <structfield>pgesrceqop</structfield> <type>oid[]</type>
+       (references <link linkend="catalog-pg-operator"><structname>pg_operator</structname></link>.<structfield>oid</structfield>)
+      </para>
+      <para>
+       For an edge, an array of equality operators for
+       <structfield>pgesrcref</structfield> =
+       <structfield>pgesrckey</structfield> comparison. (Null for a vertex.)
+       </para></entry>
+     </row>
+
      <row>
       <entry role="catalog_table_entry"><para role="column_definition">
        <structfield>pgedestkey</structfield> <type>int2[]</type>
@@ -6483,6 +6495,18 @@ SCRAM-SHA-256$<replaceable>&lt;iteration count&gt;</replaceable>:<replaceable>&l
        and the destination vertex.
       </para></entry>
      </row>
+
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       <structfield>pgedesteqop</structfield> <type>oid[]</type>
+       (references <link linkend="catalog-pg-operator"><structname>pg_operator</structname></link>.<structfield>oid</structfield>)
+      </para>
+      <para>
+       For an edge, an array of equality operators for
+       <structfield>pgedestref</structfield> =
+       <structfield>pgedestkey</structfield> comparison. (Null for a vertex.)
+       </para></entry>
+     </row>
     </tbody>
    </tgroup>
   </table>
@@ -6754,6 +6778,31 @@ SCRAM-SHA-256$<replaceable>&lt;iteration count&gt;</replaceable>:<replaceable>&l
        multiple times in different elements and labels.)
       </para></entry>
      </row>
+
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       <structfield>pgptypmod</structfield> <type>int4</type>
+      </para>
+      <para>
+      <literal>typmod</literal> to be applied to the data type of this property.
+      (This is required to be fixed for a given property in a property graph,
+      even if the property is defined multiple times in different elements and
+      labels.)
+      </para></entry>
+     </row>
+
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       <structfield>pgpcollation</structfield> <type>oid</type>
+       (references <link linkend="catalog-pg-collation"><structname>pg_collation</structname></link>.<structfield>oid</structfield>)
+      </para>
+      <para>
+       The defined collation of this property, or zero if the property is not of
+       a collatable data type.  (This is required to be fixed for a given
+       property in a property graph, even if the property is defined multiple
+       times in different elements and labels.)
+      </para></entry>
+     </row>
     </tbody>
    </tgroup>
   </table>
diff --git a/src/backend/catalog/information_schema.sql b/src/backend/catalog/information_schema.sql
index 279388bdf75..9b793a0cadf 100644
--- a/src/backend/catalog/information_schema.sql
+++ b/src/backend/catalog/information_schema.sql
@@ -3271,9 +3271,9 @@ CREATE VIEW pg_property_data_types AS
            CAST(null AS sql_identifier) AS character_set_catalog,
            CAST(null AS sql_identifier) AS character_set_schema,
            CAST(null AS sql_identifier) AS character_set_name,
-           CAST(null AS sql_identifier) AS collation_catalog, -- FIXME
-           CAST(null AS sql_identifier) AS collation_schema, -- FIXME
-           CAST(null AS sql_identifier) AS collation_name, -- FIXME
+           CAST(current_database() AS sql_identifier) AS collation_catalog,
+           CAST(nc.nspname AS sql_identifier) AS collation_schema,
+           CAST(c.collname AS sql_identifier) AS collation_name,
            CAST(null AS cardinal_number) AS numeric_precision,
            CAST(null AS cardinal_number) AS numeric_precision_radix,
            CAST(null AS cardinal_number) AS numeric_scale,
@@ -3297,6 +3297,8 @@ CREATE VIEW pg_property_data_types AS
          JOIN (pg_type t JOIN pg_namespace nt ON (t.typnamespace = nt.oid)) ON pgp.pgptypid = t.oid
          LEFT JOIN (pg_type bt JOIN pg_namespace nbt ON (bt.typnamespace = nbt.oid))
            ON (t.typtype = 'd' AND t.typbasetype = bt.oid)
+         LEFT JOIN (pg_collation c JOIN pg_namespace nc ON (c.collnamespace = nc.oid))
+           ON pgp.pgpcollation = c.oid AND (nc.nspname, c.collname) <> ('pg_catalog', 'default')
 
     WHERE pg.relkind = 'g'
           AND (NOT pg_is_other_temp_schema(npg.oid))
diff --git a/src/backend/commands/propgraphcmds.c b/src/backend/commands/propgraphcmds.c
index bf333dd2dc2..c26976b2a2a 100644
--- a/src/backend/commands/propgraphcmds.c
+++ b/src/backend/commands/propgraphcmds.c
@@ -14,20 +14,27 @@
 
 #include "access/genam.h"
 #include "access/htup_details.h"
+#include "access/nbtree.h"
 #include "access/table.h"
 #include "access/xact.h"
 #include "catalog/catalog.h"
 #include "catalog/indexing.h"
 #include "catalog/namespace.h"
 #include "catalog/pg_class.h"
+#include "catalog/pg_collation_d.h"
+#include "catalog/pg_operator_d.h"
 #include "catalog/pg_propgraph_element.h"
 #include "catalog/pg_propgraph_element_label.h"
 #include "catalog/pg_propgraph_label.h"
 #include "catalog/pg_propgraph_label_property.h"
 #include "catalog/pg_propgraph_property.h"
+#include "commands/defrem.h"
 #include "commands/propgraphcmds.h"
 #include "commands/tablecmds.h"
 #include "nodes/nodeFuncs.h"
+#include "parser/parse_coerce.h"
+#include "parser/parse_collate.h"
+#include "parser/parse_oper.h"
 #include "parser/parse_relation.h"
 #include "parser/parse_target.h"
 #include "utils/array.h"
@@ -52,12 +59,14 @@ struct element_info
 	Oid			srcrelid;
 	ArrayType  *srckey;
 	ArrayType  *srcref;
+	ArrayType  *srceqop;
 
 	char	   *destvertex;
 	Oid			destvertexid;
 	Oid			destrelid;
 	ArrayType  *destkey;
 	ArrayType  *destref;
+	ArrayType  *desteqop;
 
 	List	   *labels;
 };
@@ -68,8 +77,8 @@ static ArrayType *propgraph_element_get_key(ParseState *pstate, const List *keyc
 static void propgraph_edge_get_ref_keys(ParseState *pstate, const List *keycols, const List *refcols,
 										Relation edge_rel, Relation ref_rel,
 										const char *aliasname, int location, const char *type,
-										ArrayType **outkey, ArrayType **outref);
-static ArrayType *array_from_column_list(ParseState *pstate, const List *colnames, int location, Relation element_rel);
+										ArrayType **outkey, ArrayType **outref, ArrayType **outeqop);
+static AttrNumber *array_from_column_list(ParseState *pstate, const List *colnames, int location, Relation element_rel);
 static ArrayType *array_from_attnums(int numattrs, const AttrNumber *attnums);
 static Oid	insert_element_record(ObjectAddress pgaddress, struct element_info *einfo);
 static Oid	insert_label_record(Oid graphid, Oid peoid, const char *label);
@@ -217,10 +226,10 @@ CreatePropGraph(ParseState *pstate, const CreatePropGraphStmt *stmt)
 
 		propgraph_edge_get_ref_keys(pstate, edge->esrckey, edge->esrcvertexcols, rel, srcrel,
 									einfo->aliasname, edge->location, "SOURCE",
-									&einfo->srckey, &einfo->srcref);
+									&einfo->srckey, &einfo->srcref, &einfo->srceqop);
 		propgraph_edge_get_ref_keys(pstate, edge->edestkey, edge->edestvertexcols, rel, destrel,
 									einfo->aliasname, edge->location, "DESTINATION",
-									&einfo->destkey, &einfo->destref);
+									&einfo->destkey, &einfo->destref, &einfo->desteqop);
 
 		einfo->labels = edge->labels;
 
@@ -336,7 +345,8 @@ propgraph_element_get_key(ParseState *pstate, const List *key_clause, Relation e
 	}
 	else
 	{
-		a = array_from_column_list(pstate, key_clause, location, element_rel);
+		a = array_from_attnums(list_length(key_clause),
+							   array_from_column_list(pstate, key_clause, location, element_rel));
 	}
 
 	return a;
@@ -360,8 +370,15 @@ static void
 propgraph_edge_get_ref_keys(ParseState *pstate, const List *keycols, const List *refcols,
 							Relation edge_rel, Relation ref_rel,
 							const char *aliasname, int location, const char *type,
-							ArrayType **outkey, ArrayType **outref)
+							ArrayType **outkey, ArrayType **outref, ArrayType **outeqop)
 {
+	int			nkeys;
+	AttrNumber *keyattnums;
+	AttrNumber *refattnums;
+	Oid		   *keyeqops;
+	Datum	   *datums;
+	int			i;
+
 	Assert((keycols && refcols) || (!keycols && !refcols));
 
 	if (keycols)
@@ -372,8 +389,89 @@ propgraph_edge_get_ref_keys(ParseState *pstate, const List *keycols, const List
 					errmsg("mismatching number of columns in %s vertex definition of edge \"%s\"", type, aliasname),
 					parser_errposition(pstate, location));
 
-		*outkey = array_from_column_list(pstate, keycols, location, edge_rel);
-		*outref = array_from_column_list(pstate, refcols, location, ref_rel);
+		nkeys = list_length(keycols);
+		keyattnums = array_from_column_list(pstate, keycols, location, edge_rel);
+		refattnums = array_from_column_list(pstate, refcols, location, ref_rel);
+		keyeqops = palloc_array(Oid, nkeys);
+
+		for (i = 0; i < nkeys; i++)
+		{
+			Oid			keytype;
+			int32		keytypmod;
+			Oid			keycoll;
+			Oid			reftype;
+			int32		reftypmod;
+			Oid			refcoll;
+			Oid			opc;
+			Oid			opf;
+			StrategyNumber strategy;
+
+			/*
+			 * Lookup equality operator to be used for edge and vertex key.
+			 * Vertex key is equivalent to primary key and edge key is similar
+			 * to foreign key since edge key references vertex key. Hence
+			 * vertex key is used as left operand and edge key is used as
+			 * right operand. The method used to find the equality operators
+			 * is similar to the method used to find equality operators for
+			 * FK/PK comparison in ATAddForeignKeyConstraint() except that
+			 * opclass of the the vertex key type is used as a starting point.
+			 * Since we need only equality operators we use both BT and HASH
+			 * strategies.
+			 *
+			 * If the required operators do not exist, we can not construct
+			 * quals linking an edge to its adjacent vertexes.
+			 */
+			get_atttypetypmodcoll(RelationGetRelid(edge_rel), keyattnums[i], &keytype, &keytypmod, &keycoll);
+			get_atttypetypmodcoll(RelationGetRelid(ref_rel), refattnums[i], &reftype, &reftypmod, &refcoll);
+			keyeqops[i] = InvalidOid;
+			strategy = BTEqualStrategyNumber;
+			opc = GetDefaultOpClass(reftype, BTREE_AM_OID);
+			if (!OidIsValid(opc))
+			{
+				opc = GetDefaultOpClass(reftype, HASH_AM_OID);
+				strategy = HTEqualStrategyNumber;
+			}
+			if (OidIsValid(opc))
+			{
+				opf = get_opclass_family(opc);
+				if (OidIsValid(opf))
+				{
+					keyeqops[i] = get_opfamily_member(opf, reftype, keytype, strategy);
+					if (!OidIsValid(keyeqops[i]))
+					{
+						/* Last resort, implicit cast. */
+						if (can_coerce_type(1, &keytype, &reftype, COERCION_IMPLICIT))
+							keyeqops[i] = get_opfamily_member(opf, reftype, reftype, strategy);
+					}
+				}
+			}
+
+			if (!OidIsValid(keyeqops[i]))
+				ereport(ERROR,
+						errcode(ERRCODE_SYNTAX_ERROR),
+						errmsg("no equality operator exists for %s key comparison of edge \"%s\"",
+							   type, aliasname),
+						parser_errposition(pstate, location));
+
+			/*
+			 * If collations of key attribute and referenced attribute are
+			 * different, an edge may end up being adjacent to undesired
+			 * vertexes.  Prohibit such a case.
+			 *
+			 * PK/FK allows different collations as long as they are
+			 * deterministic for backward compatibility. But we can be a bit
+			 * stricter here and follow SQL standard.
+			 */
+			if (keycoll != refcoll &&
+				keycoll != DEFAULT_COLLATION_OID && refcoll != DEFAULT_COLLATION_OID &&
+				OidIsValid(keycoll) && OidIsValid(refcoll))
+				ereport(ERROR,
+						errcode(ERRCODE_SYNTAX_ERROR),
+						errmsg("collation mismatch in %s key of edge \"%s\": %s vs. %s",
+							   type, aliasname,
+							   get_collation_name(keycoll), get_collation_name(refcoll)),
+						parser_errposition(pstate, location));
+		}
 	}
 	else
 	{
@@ -402,25 +500,34 @@ propgraph_edge_get_ref_keys(ParseState *pstate, const List *keycols, const List
 
 		Assert(fk);
 
-		*outkey = array_from_attnums(fk->nkeys, fk->conkey);
-		*outref = array_from_attnums(fk->nkeys, fk->confkey);
+		nkeys = fk->nkeys;
+		keyattnums = fk->conkey;
+		refattnums = fk->confkey;
+		keyeqops = fk->conpfeqop;
 	}
+
+	*outkey = array_from_attnums(nkeys, keyattnums);
+	*outref = array_from_attnums(nkeys, refattnums);
+	datums = (Datum *) palloc(sizeof(Datum) * nkeys);
+	for (i = 0; i < nkeys; i++)
+		datums[i] = ObjectIdGetDatum(keyeqops[i]);
+	*outeqop = construct_array_builtin(datums, nkeys, OIDOID);
 }
 
 /*
  * Convert list of column names in the specified relation into an array of
  * column numbers.
  */
-static ArrayType *
+static AttrNumber *
 array_from_column_list(ParseState *pstate, const List *colnames, int location, Relation element_rel)
 {
 	int			numattrs;
-	Datum	   *attnumsd;
+	AttrNumber *attnums;
 	int			i;
 	ListCell   *lc;
 
 	numattrs = list_length(colnames);
-	attnumsd = palloc_array(Datum, numattrs);
+	attnums = palloc_array(AttrNumber, numattrs);
 
 	i = 0;
 	foreach(lc, colnames)
@@ -436,14 +543,14 @@ array_from_column_list(ParseState *pstate, const List *colnames, int location, R
 					 errmsg("column \"%s\" of relation \"%s\" does not exist",
 							colname, get_rel_name(relid)),
 					 parser_errposition(pstate, location)));
-		attnumsd[i++] = Int16GetDatum(attnum);
+		attnums[i++] = attnum;
 	}
 
 	for (int j = 0; j < numattrs; j++)
 	{
 		for (int k = j + 1; k < numattrs; k++)
 		{
-			if (DatumGetInt16(attnumsd[j]) == DatumGetInt16(attnumsd[k]))
+			if (attnums[j] == attnums[k])
 				ereport(ERROR,
 						(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
 						 errmsg("graph key columns list must not contain duplicates"),
@@ -451,7 +558,7 @@ array_from_column_list(ParseState *pstate, const List *colnames, int location, R
 		}
 	}
 
-	return construct_array_builtin(attnumsd, numattrs, INT2OID);
+	return attnums;
 }
 
 static ArrayType *
@@ -484,6 +591,23 @@ array_of_attnums_to_objectaddrs(Oid relid, ArrayType *arr, ObjectAddresses *addr
 	}
 }
 
+static void
+array_of_opers_to_objectaddrs(ArrayType *arr, ObjectAddresses *addrs)
+{
+	Datum	   *opersd;
+	int			numopers;
+
+	deconstruct_array_builtin(arr, OIDOID, &opersd, NULL, &numopers);
+
+	for (int i = 0; i < numopers; i++)
+	{
+		ObjectAddress referenced;
+
+		ObjectAddressSet(referenced, OperatorRelationId, DatumGetObjectId(opersd[i]));
+		add_exact_object_address(&referenced, addrs);
+	}
+}
+
 /*
  * Insert a record for an element into the pg_propgraph_element catalog.  Also
  * inserts labels and properties into their respective catalogs.
@@ -524,6 +648,10 @@ insert_element_record(ObjectAddress pgaddress, struct element_info *einfo)
 		values[Anum_pg_propgraph_element_pgesrcref - 1] = PointerGetDatum(einfo->srcref);
 	else
 		nulls[Anum_pg_propgraph_element_pgesrcref - 1] = true;
+	if (einfo->srceqop)
+		values[Anum_pg_propgraph_element_pgesrceqop - 1] = PointerGetDatum(einfo->srceqop);
+	else
+		nulls[Anum_pg_propgraph_element_pgesrceqop - 1] = true;
 	if (einfo->destkey)
 		values[Anum_pg_propgraph_element_pgedestkey - 1] = PointerGetDatum(einfo->destkey);
 	else
@@ -532,6 +660,10 @@ insert_element_record(ObjectAddress pgaddress, struct element_info *einfo)
 		values[Anum_pg_propgraph_element_pgedestref - 1] = PointerGetDatum(einfo->destref);
 	else
 		nulls[Anum_pg_propgraph_element_pgedestref - 1] = true;
+	if (einfo->desteqop)
+		values[Anum_pg_propgraph_element_pgedesteqop - 1] = PointerGetDatum(einfo->desteqop);
+	else
+		nulls[Anum_pg_propgraph_element_pgedesteqop - 1] = true;
 
 	tup = heap_form_tuple(RelationGetDescr(rel), values, nulls);
 	CatalogTupleInsert(rel, tup);
@@ -549,13 +681,17 @@ insert_element_record(ObjectAddress pgaddress, struct element_info *einfo)
 	add_exact_object_address(&referenced, addrs);
 	array_of_attnums_to_objectaddrs(einfo->relid, einfo->key, addrs);
 
-	/* Add dependencies on vertices */
+	/*
+	 * Add dependencies on vertices and equality operators used for key
+	 * comparison.
+	 */
 	if (einfo->srcvertexid)
 	{
 		ObjectAddressSet(referenced, PropgraphElementRelationId, einfo->srcvertexid);
 		add_exact_object_address(&referenced, addrs);
 		array_of_attnums_to_objectaddrs(einfo->relid, einfo->srckey, addrs);
 		array_of_attnums_to_objectaddrs(einfo->srcrelid, einfo->srcref, addrs);
+		array_of_opers_to_objectaddrs(einfo->srceqop, addrs);
 	}
 	if (einfo->destvertexid)
 	{
@@ -563,10 +699,9 @@ insert_element_record(ObjectAddress pgaddress, struct element_info *einfo)
 		add_exact_object_address(&referenced, addrs);
 		array_of_attnums_to_objectaddrs(einfo->relid, einfo->destkey, addrs);
 		array_of_attnums_to_objectaddrs(einfo->destrelid, einfo->destref, addrs);
+		array_of_opers_to_objectaddrs(einfo->desteqop, addrs);
 	}
 
-	/* TODO: dependencies on equality operators, like for foreign keys */
-
 	record_object_address_dependencies(&myself, addrs, DEPENDENCY_NORMAL);
 
 	table_close(rel, NoLock);
@@ -766,6 +901,7 @@ insert_property_records(Oid graphid, Oid ellabeloid, Oid pgerelid, const PropGra
 	table_close(rel, NoLock);
 
 	tp = transformTargetList(pstate, proplist, EXPR_KIND_PROPGRAPH_PROPERTY);
+	assign_expr_collations(pstate, (Node *) tp);
 
 	foreach(lc, tp)
 	{
@@ -784,9 +920,15 @@ insert_property_record(Oid graphid, Oid ellabeloid, Oid pgerelid, const char *pr
 {
 	Oid			propoid;
 	Oid			exprtypid;
+	int32		exprtypmod;
+	Oid			exprcollation;
 	Oid			proptypid;
+	int32		proptypmod;
+	Oid			propcollation;
 
 	exprtypid = exprType((const Node *) expr);
+	exprcollation = exprCollation((const Node *) expr);
+	exprtypmod = exprTypmod((const Node *) expr);
 
 	/*
 	 * Insert into pg_propgraph_property if not already existing.
@@ -803,6 +945,8 @@ insert_property_record(Oid graphid, Oid ellabeloid, Oid pgerelid, const char *pr
 		ObjectAddress referenced;
 
 		proptypid = exprtypid;
+		proptypmod = exprtypmod;
+		propcollation = exprcollation;
 
 		rel = table_open(PropgraphPropertyRelationId, RowExclusiveLock);
 
@@ -812,6 +956,8 @@ insert_property_record(Oid graphid, Oid ellabeloid, Oid pgerelid, const char *pr
 		namestrcpy(&propnamedata, propname);
 		values[Anum_pg_propgraph_property_pgpname - 1] = NameGetDatum(&propnamedata);
 		values[Anum_pg_propgraph_property_pgptypid - 1] = ObjectIdGetDatum(proptypid);
+		values[Anum_pg_propgraph_property_pgptypmod - 1] = Int32GetDatum(proptypmod);
+		values[Anum_pg_propgraph_property_pgpcollation - 1] = ObjectIdGetDatum(propcollation);
 
 		tup = heap_form_tuple(RelationGetDescr(rel), values, nulls);
 		CatalogTupleInsert(rel, tup);
@@ -828,7 +974,13 @@ insert_property_record(Oid graphid, Oid ellabeloid, Oid pgerelid, const char *pr
 	}
 	else
 	{
-		proptypid = GetSysCacheOid1(PROPGRAPHPROPOID, Anum_pg_propgraph_property_pgptypid, ObjectIdGetDatum(propoid));
+		HeapTuple	pgptup = SearchSysCache1(PROPGRAPHPROPOID, ObjectIdGetDatum(propoid));
+		Form_pg_propgraph_property pgpform = (Form_pg_propgraph_property) GETSTRUCT(pgptup);
+
+		proptypid = pgpform->pgptypid;
+		proptypmod = pgpform->pgptypmod;
+		propcollation = pgpform->pgpcollation;
+		ReleaseSysCache(pgptup);
 	}
 
 	/*
@@ -845,6 +997,32 @@ insert_property_record(Oid graphid, Oid ellabeloid, Oid pgerelid, const char *pr
 				errdetail("In a property graph, a property of the same name has to have the same data type in each label."));
 	}
 
+	/* Similarly for collation */
+	if (propcollation != exprcollation)
+	{
+		ereport(ERROR,
+				errcode(ERRCODE_SYNTAX_ERROR),
+				errmsg("property \"%s\" collation mismatch: %s vs. %s",
+					   propname, get_collation_name(propcollation), get_collation_name(exprcollation)),
+				errdetail("In a property graph, a property of the same name has to have the same collation in each label."));
+	}
+
+	/*
+	 * And typmod. It does not seem to be necessary to enforce typmod
+	 * consistency across properties with the same name. But when properties
+	 * with the same name have different typmods, it is not clear which one
+	 * should be used as the typmod of the graph property when typmod of a
+	 * property is requested before fetching any of the property expressions.
+	 */
+	if (proptypmod != exprtypmod)
+	{
+		ereport(ERROR,
+				errcode(ERRCODE_SYNTAX_ERROR),
+				errmsg("property \"%s\" data type modifier mismatch: %d vs. %d",
+					   propname, proptypmod, exprtypmod),
+				errdetail("In a property graph, a property of the same name has to have the same type modifier in each label."));
+	}
+
 	/*
 	 * Insert into pg_propgraph_label_property
 	 */
@@ -1236,10 +1414,10 @@ AlterPropGraph(ParseState *pstate, const AlterPropGraphStmt *stmt)
 
 		propgraph_edge_get_ref_keys(pstate, edge->esrckey, edge->esrcvertexcols, rel, srcrel,
 									einfo->aliasname, edge->location, "SOURCE",
-									&einfo->srckey, &einfo->srcref);
+									&einfo->srckey, &einfo->srcref, &einfo->srceqop);
 		propgraph_edge_get_ref_keys(pstate, edge->edestkey, edge->edestvertexcols, rel, destrel,
 									einfo->aliasname, edge->location, "DESTINATION",
-									&einfo->destkey, &einfo->destref);
+									&einfo->destkey, &einfo->destref, &einfo->desteqop);
 
 		einfo->labels = edge->labels;
 
diff --git a/src/backend/nodes/nodeFuncs.c b/src/backend/nodes/nodeFuncs.c
index 3e4c52b89c5..81463e67117 100644
--- a/src/backend/nodes/nodeFuncs.c
+++ b/src/backend/nodes/nodeFuncs.c
@@ -540,8 +540,7 @@ exprTypmod(const Node *expr)
 		case T_PlaceHolderVar:
 			return exprTypmod((Node *) ((const PlaceHolderVar *) expr)->phexpr);
 		case T_GraphPropertyRef:
-			/* TODO */
-			return -1;
+			return ((const GraphPropertyRef *) expr)->typmod;
 		default:
 			break;
 	}
@@ -1065,7 +1064,7 @@ exprCollation(const Node *expr)
 			coll = exprCollation((Node *) ((const PlaceHolderVar *) expr)->phexpr);
 			break;
 		case T_GraphPropertyRef:
-			coll = DEFAULT_COLLATION_OID;	/* FIXME */
+			coll = ((const GraphPropertyRef *) expr)->collation;
 			break;
 		default:
 			elog(ERROR, "unrecognized node type: %d", (int) nodeTag(expr));
diff --git a/src/backend/parser/parse_collate.c b/src/backend/parser/parse_collate.c
index 60bcc5f4145..8f912065a01 100644
--- a/src/backend/parser/parse_collate.c
+++ b/src/backend/parser/parse_collate.c
@@ -546,6 +546,7 @@ assign_collations_walker(Node *node, assign_collations_context *context)
 		case T_CaseTestExpr:
 		case T_SetToDefault:
 		case T_CurrentOfExpr:
+		case T_GraphPropertyRef:
 
 			/*
 			 * General case for childless expression nodes.  These should
@@ -571,13 +572,6 @@ assign_collations_walker(Node *node, assign_collations_context *context)
 			location = exprLocation(node);
 			break;
 
-		case T_GraphPropertyRef:
-			/* FIXME */
-			collation = DEFAULT_COLLATION_OID;
-			strength = COLLATE_IMPLICIT;
-			location = -1;
-			break;
-
 		default:
 			{
 				/*
diff --git a/src/backend/parser/parse_graphtable.c b/src/backend/parser/parse_graphtable.c
index b088306b5b3..a8769a67b6a 100644
--- a/src/backend/parser/parse_graphtable.c
+++ b/src/backend/parser/parse_graphtable.c
@@ -56,18 +56,24 @@ transformGraphTablePropertyRef(ParseState *pstate, ColumnRef *cref)
 		if (list_member(gpstate->variables, field1))
 		{
 			GraphPropertyRef *gpr = makeNode(GraphPropertyRef);
-			Oid			propid;
+			HeapTuple	pgptup;
+			Form_pg_propgraph_property pgpform;
 
-			propid = GetSysCacheOid2(PROPGRAPHPROPNAME, Anum_pg_propgraph_property_oid, ObjectIdGetDatum(gpstate->graphid), CStringGetDatum(propname));
-			if (!propid)
+			pgptup = SearchSysCache2(PROPGRAPHPROPNAME, ObjectIdGetDatum(gpstate->graphid), CStringGetDatum(propname));
+			if (!HeapTupleIsValid(pgptup))
 				ereport(ERROR,
 						errcode(ERRCODE_SYNTAX_ERROR),
 						errmsg("property \"%s\" does not exist", propname));
+			pgpform = (Form_pg_propgraph_property) GETSTRUCT(pgptup);
 
 			gpr->location = cref->location;
 			gpr->elvarname = elvarname;
-			gpr->propid = propid;
-			gpr->typeId = GetSysCacheOid1(PROPGRAPHPROPOID, Anum_pg_propgraph_property_pgptypid, ObjectIdGetDatum(propid));
+			gpr->propid = pgpform->oid;
+			gpr->typeId = pgpform->pgptypid;
+			gpr->typmod = pgpform->pgptypmod;
+			gpr->collation = pgpform->pgpcollation;
+
+			ReleaseSysCache(pgptup);
 
 			return (Node *) gpr;
 		}
